#include "Parser.h"
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// НАСТРОЙКИ
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#define SD_CS_PIN 4 // пин Chip Select для SD-карты
#define PROGRAM_FILENAME F("program.txt") // имя файла с микропрограммой
#define COMMAND_DELIMITER '\t' // разделитель между командами
#define SERIAL_SPEED 57600 // скорость работы Serial
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// обработчик следующей команды из файла
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void ON_COMMAND(int command)
{
  // тут что-то делаем с командой, пока - просто выводим в Serial
  Serial << F("Command to execute: ") << command << ENDLINE;
  
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void setup() 
{
  Serial.begin(SERIAL_SPEED);
  if(!SD.begin(SD_CS_PIN))
  {
    Serial << F("CAN'T INIT SD!") << ENDLINE;
    while(true);
  }

  Parser.setup(COMMAND_DELIMITER);

  if(!Parser.load(PROGRAM_FILENAME))
  {
    Serial << F("CAN'T LOAD PROGRAM!") << ENDLINE;
    while(true);
  }

}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void loop() 
{
  // обновляем парсер
  if(!Parser.isDone()) // пока есть команды - просим выполнить следующую.
  {
    // такой механизм позволяет избавиться от блокирующего исполнения, т.к. просить выполнить следующую команду можно
    // неблокирующе, по факту выполнения предыдущей. В простейшем случае - можно в событии ON_COMMAND делать блокирующую работу
    // (т.е. не выходить из функции, пока не будет выполнено требуемое действие), тогда всё выполнение пойдёт линейно.
    Parser.processNextCommand();
  }

}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------

