//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#include "Parser.h"
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
extern "C" {
static void __nohandler(uint8_t* b, int dummy){}
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void ON_COMMAND(int command) __attribute__ ((weak, alias("__nohandler")));
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// Parser
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
ParserClass Parser;
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
ParserClass::ParserClass()
{
  commandDelimiter = '\t';
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void ParserClass::setup(char commandDelim)
{
  commandDelimiter = commandDelim;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
bool ParserClass::isDone()
{
  if(!workFile)
    return true;

    return !(workFile.available() > 0);
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
bool ParserClass::load(const String& fileName)
{
  if(workFile)
    workFile.close();

   workFile = SD.open(fileName.c_str(),FILE_READ);

   return workFile;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
bool ParserClass::executeCommand(const String& command)
{
  if(!command.length())
    return false;

  ON_COMMAND(command.toInt());

  return true;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void ParserClass::processNextCommand()
{
  String command;
  while(!isDone())
  {
    char ch = workFile.read();

    if(ch == -1)
    {
      executeCommand(command);
      return;
    }

      if(ch == '\r')
        continue;
      else
      if(ch == commandDelimiter || ch == '\n')
      {
        if(executeCommand(command))
          return;
      }
      else
        command += ch;
  }
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------

