#ifndef _PARSER_H
#define _PARSER_H
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#include <Arduino.h>
#include <SD.h>
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
template <typename T> inline Stream& operator << (Stream &s, T n) { s.print(n); return s; }
#define ENDLINE '\n'
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
extern "C" {
  void ON_COMMAND(int command);
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class ParserClass
{
  public:
    ParserClass();
    
    bool isDone();
    bool load(const String& fileName);
    void processNextCommand();

    void setup(char commandDelim);

  private:

      File workFile;
      char commandDelimiter;

      bool executeCommand(const String& command);
      

    
  
};
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
extern ParserClass Parser;
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#endif

